create or replace procedure pHR_SlryCalcGrossGE (
  cKljuc            IN       VARCHAR2 DEFAULT NULL,
  cODVecDelMest     IN       VARCHAR2 DEFAULT NULL,
  cObdobje          IN       VARCHAR2 DEFAULT NULL,
  cDelavec          IN       VARCHAR2 DEFAULT NULL,
  nVrednostIndeks   IN       NUMBER DEFAULT NULL,
  nODPovpODFa1      IN       NUMBER DEFAULT NULL,
  nODPovpODFa2      IN       NUMBER DEFAULT NULL,
  nODPovpODFa3      IN       NUMBER DEFAULT NULL,
  nODPovpODFa4      IN       NUMBER DEFAULT NULL,
  nODPovpODFa5      IN       NUMBER DEFAULT NULL,
  nODPovpODFa6      IN       NUMBER DEFAULT NULL,
  nODPovpODFa7      IN       NUMBER DEFAULT NULL,
  nODPovpODFa8      IN       NUMBER DEFAULT NULL,
  nODPovpODFa9      IN       NUMBER DEFAULT NULL,
  nODPovpODFa10     IN       NUMBER DEFAULT NULL,
  nODPovpODFa11     IN       NUMBER DEFAULT NULL,
  nODPovpODFa12     IN       NUMBER DEFAULT NULL,
  nODPovpODFa13     IN       NUMBER DEFAULT NULL,
  nODPovpODFa14     IN       NUMBER DEFAULT NULL,
  nODPovpODFa15     IN       NUMBER DEFAULT NULL,
  iDMID             IN       NUMBER DEFAULT NULL,
  cOdDelDelMesto    IN       VARCHAR2 DEFAULT NULL,
  nRoundOd          IN       NUMBER DEFAULT NULL,
  nDayAllowNo       IN       NUMBER DEFAULT NULL,
  dDatumIzplacila   IN       DATE DEFAULT NULL,
  dDateCalcLOS      IN       DATE DEFAULT NULL,
  cFormulaZaBruto   IN       VARCHAR2 DEFAULT NULL,

  nOdDelDel29       IN OUT   NUMBER
)
as

  cMsg              VARCHAR2 (800);
  nOdDelDel07       NUMBER (19, 4);
  nOdDelDel20       NUMBER (19, 4);
  lFakN             NUMBER (1, 0);
  nZ070             NUMBER (19, 4);
  nZ105             NUMBER (19, 4) := 0;
  nZ106             NUMBER (19, 4) := 0;
  nZ107             NUMBER (19, 4) := 0;
  nZ108             NUMBER (19, 4) := 0;
  nZ113             NUMBER (19, 4) := 0;
  nZ114             NUMBER (19, 4) := 0;
  nZ115             NUMBER (19, 4) := 0;
  nZ116             NUMBER (19, 4) := 0;
  nZ117             NUMBER (19, 4) := 0;
  nZ118             NUMBER (19, 4) := 0;
  nZ119             NUMBER (19, 4) := 0;
  nZ124             NUMBER (19, 4) := 0;
  cIsDirector       VARCHAR2 (1);
  nOdRazredFaktor   NUMBER (19, 8);
  cRazred           VARCHAR2 (6);
  nNewDel29         NUMBER (19, 4);

begin
  cMsg := 'Preracun bruto GE.';
  pHR_SlryCalcLogAdd(cMsg);

  nZ070 := nOdDelDel29;

  begin
    select
      acIsDirector
    into
      cIsDirector
    from vHR_Job
    where acName = cOdDelDelMesto;
  exception
     when no_data_found
     then
        null;
  end;

  if cIsDirector = 'T' -- je direktor nZ114, nZ115
  then
    select
      anWrk07
    into
      nOdDelDel07
    from lHR_TODObrDel
    where anjobID = iDMID;

    nZ115 := nZ070 * nOdDelDel07 / 100;
    pHR_RoundFin (nZ115, nRoundOd, nZ115);

    nZ114 := nZ070 - nZ115;
  else -- ni direktor nZ105, nZ106, nZ107, nZ108, nZ113
    select
      anZ105,
      anZ106
    into
      nZ105,
      nZ106
    from tHR_Prsnjob
    where acWorker = cDelavec and anID = iDMID;

    if nZ106 > 0 then
    begin
      if nZ070 > nZ106 then
        nZ107 := nZ070 - nZ106;
      else
        nZ107 := 0;
      end if;
    end;
    end if;
    if nZ106 <= 0 then
      nZ107 := nZ070 - nZ105;
    end if;
    if nZ107 < 0
    then
      nZ107 := 0;
    end if;

    if dDatumIzplacila >= To_Date('2009/01/01', 'yyyy/mm/dd')
    then
      nZ113 := nZ107 * 0.50; -- 0.50 je Faktor za odpravo nesorazmerij po 1.1.2009
    else
      nZ113 := nZ107 * 0.75; -- 0.75 je Faktor za odpravo nesorazmerij
    end if;

    nZ108 := nZ070 - nZ113;
  end if;

  select
    acIGroupGE
  into
    cRazred
  from tHR_Prsnjob
  where acWorker = cDelavec and anId = iDMID;

  if NVL(cRazred, ' ') <> ' ' -- sprememba razreda nZ116, nZ117, nZ118, nZ119
  then
    begin
      nOdRazredFaktor := fHR_GetSlryIGFactor(cRazred, cObdobje);
    exception
       when no_data_found
       then
          null;
    end;

    pHR_SlryCalcByFormula ('T', cODVecDelMest, cObdobje,
                           cDelavec, cFormulaZaBruto,
                           'A', '', iDMID, 0, 0,
                           0, 0, 0, 0,
                           0, nVrednostIndeks, 0, 0, 0,
                           nOdRazredFaktor,
                           nODPovpODFa1, nODPovpODFa2, nODPovpODFa3, nODPovpODFa4, nODPovpODFa5,
                           nODPovpODFa6, nODPovpODFa7, nODPovpODFa8, nODPovpODFa9, nODPovpODFa10,
                           nODPovpODFa11, nODPovpODFa12, nODPovpODFa13, nODPovpODFa14, nODPovpODFa15,
                           null, '', '', '', 1, nDayAllowNo, dDatumIzplacila,
                           dDateCalcLOS,
                           nNewDel29, nOdDelDel20, lFakN);

    pHR_RoundFin (nNewDel29, nRoundOd, nNewDel29);

    if nNewDel29 < nOdDelDel29 -- ce je zmanjsanje tarifnega razreda
    then
      nZ117 := nOdDelDel29 - nNewDel29;
      nZ116 := nZ108 + nZ114 - nZ117;
    end if;

    if nNewDel29 > nOdDelDel29 -- ce je povecanje tarifnega razreda
    then
      nZ119 := nNewDel29 - nOdDelDel29;
      nZ118 := nZ108 + nZ114 + nZ119;
    end if;

    if nZ116 > 0 or nZ118 > 0
    then
      nZ108 := 0;
      nZ113 := 0;
      nZ114 := 0;
      nZ115 := 0;
    end if;
  end if;

  nOdDelDel29 := nZ108 + nZ114 + nZ116 + nZ118; -- samo eden od teh je razilcen od 0

  select
    sum(D.anZ120)
  into
    nZ124
  from tHR_SlryCalcJob D
  join tHR_SlryPrep O on D.acKey = O.acKey
  where D.acWorker = cDelavec
    and substring(D.acKey, 3, 4) = substring(cKljuc, 3, 4)
    and fHR_ConvertPeriod(O.acPeriod) = fHR_ConvertPeriod(cObdobje)-1
    and (cODVecDelMest <> 'T' or D.anjobID = iDMID);

  nZ124 := NVL(nZ124, 0);

  if nZ124 = 0
  then
    nZ124 := nOdDelDel29;
  end if;

  update lHR_TODObrDel set
    anZ105 = nZ105,
    anZ106 = nZ106,
    anZ107 = nZ107,
    anZ108 = nZ108,
    anZ113 = nZ113,
    anZ114 = nZ114,
    anZ115 = nZ115,
    anZ116 = nZ116,
    anZ117 = nZ117,
    anZ118 = nZ118,
    anZ119 = nZ119,
    anZ120 = nOdDelDel29,
    anZ124 = nZ124,
    anZ070 = nZ070
  where anjobID = iDMID;

  cMsg := 'Preraun bruto GE. Konec. anjobID='||LTrim(Str(iDMID, 19, 0))
       || ', anWrk29='||LTrim(Str(nOdDelDel29, 19, 4))
       || ', anZ070='||LTrim(Str(nZ070, 19, 4))
       || ', anZ115='||LTrim(Str(nZ115, 19, 4));
  pHR_SlryCalcLogAdd(cMsg);
end pHR_SlryCalcGrossGE;